function ohmWrite(a) {
    var o = choo.ohm;
    if (a === undefined) {
        $('#cc-r').val(round(o.r, 2));
        $('#cc-u').val(round(o.u, 2));
        $('#cc-i').val(round(o.i, 2));
        $('#cc-p').val(round(o.p, 2))
    } else {
        if (a.attr('id') !== $('#cc-r').attr('id')) {
            $('#cc-r').val(round(o.r, 2))
        }
        if (a.attr('id') !== $('#cc-u').attr('id')) {
            $('#cc-u').val(round(o.u, 2))
        }
        if (a.attr('id') !== $('#cc-i').attr('id')) {
            $('#cc-i').val(round(o.i, 2))
        }
        if (a.attr('id') !== $('#cc-p').attr('id')) {
            $('#cc-p').val(round(o.p, 2))
        }
    }
    return
}

function ohmInit() {
    choo.ohm = {
    r: 2.5,
    u: 3.5,
    rlock: 'u',
    ulock: 'r',
    ilock: 'r',
    plock: 'r',
    lockadvanced: false,
    lockbtn1: 'r',
    lockbtn2: 'u'
    };
    choo.ohm.i = choo.ohm.u / choo.ohm.r;
    choo.ohm.p = choo.ohm.u * choo.ohm.i;
    return
}

function ohmLoad() {
    var o = seLoad('ohm');
    if (o === undefined) {
        ohmInit();
        $('#ohm-load').hide()
    } else {
        choo.ohm = o
    }
    return
}

function clearPadlocks() {
    $('.form-group').find('i').removeClass('lb1 lb2').attr('title', '');
    return
}

function updatePadlocks(o) {
    clearPadlocks();
    if (o.lockbtn1 !== '') {
        $('#cc-' + o.lockbtn1 + '-cg').find('i').addClass('lb1').attr('title', '調整其他值時該值不變。');
        $('#cc-' + o.lockbtn2 + '-cg').find('i').addClass('lb2').attr('title', '調整' + o.lockbtn1.toUpperCase() + '時，該值不變.')
    }
    return
}

function showLocks() {
    var o = choo.ohm;
    $('.cc-lock').prop('checked', false);
    $('#cc-lockr-' + o.rlock).prop('checked', true);
    $('#cc-locku-' + o.ulock).prop('checked', true);
    $('#cc-locki-' + o.ilock).prop('checked', true);
    $('#cc-lockp-' + o.plock).prop('checked', true);
    if (o.lockadvanced) {
        $('.cc-advanced').show('blind');
        $('#cc-lockadvancedhide').show();
        $('#ohm-lockadvancedshow').hide()
    } else {
        $('.cc-advanced').hide('blind');
        $('#cc-lockadvancedhide').hide();
        $('#ohm-lockadvancedshow').show()
    }
    $('#cc-locksimple').find('.btn').removeClass('btn-primary active');
    $('#cc-locksimple').find('.btn[data-lock="' + o.lockbtn1 + '"]').addClass('btn-primary');
    $('#cc-locksimple').find('.btn[data-lock="' + o.lockbtn2 + '"]').addClass('active');
    updatePadlocks(o);
    return
}

function setCustomLock(a, v) {
    if (a === 'r') {
        choo.ohm.rlock = v
    } else if (a === 'u') {
        choo.ohm.ulock = v
    } else if (a === 'i') {
        choo.ohm.ilock = v
    } else if (a === 'p') {
        choo.ohm.plock = v
    }
    choo.ohm.lockbtn1 = '';
    choo.ohm.lockbtn2 = '';
    $('#cc-locksimple').find('.btn').removeClass('btn-primary active');
    clearPadlocks(choo.ohm);
    return
}
$(document).ready(function() {
                  $('#ohm-reset').click(function() {
                                        ohmInit();
                                        ohmWrite();
                                        showLocks();
                                        ccMenuMsg('默認設置已加載', 'success');
                                        gad('ohm', 'reset')
                                        });
                  $('#ohm-save').click(function() {
                                       var o = choo.ohm;
                                       o.lockbtn1 = $('#cc-locksimple').find('.btn-primary').attr('data-lock');
                                       o.lockbtn2 = $('#cc-locksimple').find('.active').attr('data-lock');
                                       seSave('ohm', o);
                                       $('#ohm-load').show();
                                       gad('ohm', 'save')
                                       });
                  $('#ohm-load').click(function() {
                                       ohmLoad();
                                       ohmWrite();
                                       showLocks();
                                       gad('ohm', 'load')
                                       });
                  $('.cc-lockr').change(function() {
                                        setCustomLock('r', $(this).val())
                                        });
                  $('.cc-locku').change(function() {
                                        setCustomLock('u', $(this).val())
                                        });
                  $('.cc-locki').change(function() {
                                        setCustomLock('i', $(this).val())
                                        });
                  $('.cc-lockp').change(function() {
                                        setCustomLock('p', $(this).val())
                                        });
                  $('.btn-group .cc-lock').click(function() {
                                                 var o = choo.ohm;
                                                 if (!$(this).hasClass('btn-primary')) {
                                                 o.lockbtn2 = o.lockbtn1;
                                                 o.lockbtn1 = $(this).attr('data-lock');
                                                 $('.btn-group .cc-lock').removeClass('active');
                                                 $('.btn-group .cc-lock.btn-primary').addClass('active');
                                                 $('.btn-group .cc-lock').removeClass('btn-primary');
                                                 $(this).addClass('btn-primary');
                                                 showLocks()
                                                 }
                                                 var a = $(this).attr('data-lock');
                                                 if (a !== 'r') {
                                                 o.rlock = a
                                                 }
                                                 if (a !== 'u') {
                                                 o.ulock = a
                                                 }
                                                 if (a !== 'i') {
                                                 o.ilock = a
                                                 }
                                                 if (a !== 'p') {
                                                 o.plock = a
                                                 }
                                                 showLocks();
                                                 ohmWrite()
                                                 });
                  $('.ohm-lockadvancedshowhide').click(function() {
                                                       if (choo.ohm.lockadvanced) {
                                                       choo.ohm.lockadvanced = false
                                                       } else {
                                                       choo.ohm.lockadvanced = true
                                                       }
                                                       showLocks();
                                                       ohmWrite();
                                                       gad('ohm', 'lockadvanced', bool2int(choo.ohm.lockadvanced))
                                                       });
                  $('#cc-r').change(function() {
                                    var o = choo.ohm;
                                    o.r = parseFloat($(this).val());
                                    if (o.rlock === 'u') {
                                    o.i = o.u / o.r;
                                    o.p = o.u * o.i
                                    } else if (o.rlock === 'i') {
                                    o.u = o.i * o.r;
                                    o.p = o.u * o.i
                                    } else if (o.rlock === 'p') {
                                    o.i = Math.sqrt(o.p / o.r);
                                    o.u = o.i * o.r
                                    }
                                    ohmWrite($(this));
                                    gad('ohm', 'r', o.r)
                                    });
                  $('#cc-u').change(function() {
                                    var o = choo.ohm;
                                    o.u = parseFloat($(this).val());
                                    if (o.ulock === 'r') {
                                    o.i = o.u / o.r;
                                    o.p = o.u * o.i
                                    } else if (o.ulock === 'i') {
                                    o.r = o.u / o.i;
                                    o.p = o.u * o.i
                                    } else if (o.ulock === 'p') {
                                    o.r = (o.u * o.u) / o.p;
                                    o.i = o.u / o.r
                                    }
                                    ohmWrite($(this));
                                    gad('ohm', 'u', o.u)
                                    });
                  $('#cc-i').change(function() {
                                    var o = choo.ohm;
                                    o.i = parseFloat($(this).val());
                                    if (o.ilock === 'r') {
                                    o.u = o.r * o.i;
                                    o.p = o.u * o.i
                                    } else if (o.ilock === 'u') {
                                    o.r = o.u / o.i;
                                    o.p = o.u * o.i
                                    } else if (o.ilock === 'p') {
                                    o.u = o.p / o.i;
                                    o.r = o.u / o.i
                                    }
                                    ohmWrite($(this));
                                    gad('ohm', 'i', o.i)
                                    });
                  $('#cc-p').change(function() {
                                    var o = choo.ohm;
                                    o.p = parseFloat($(this).val());
                                    if (o.plock === 'r') {
                                    o.u = Math.sqrt(o.p * o.r);
                                    o.i = o.u / o.r
                                    } else if (o.plock === 'u') {
                                    o.r = (o.u * o.u) / o.p;
                                    o.i = o.u / o.r
                                    } else if (o.plock === 'i') {
                                    o.r = o.p / (o.i * o.i);
                                    o.u = o.i * o.r
                                    }
                                    ohmWrite($(this));
                                    gad('ohm', 'p', o.p)
                                    });
                  ohmLoad();
                  ohmWrite();
                  showLocks();
                  return
                  });